/*
 Copyright 2015 Nicolas Melot

 This file is part of Crown.

 Crown is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Crown is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Crown. If not, see <http://www.gnu.org/licenses/>.

*/


#include <pelib/Algebra.hpp>

#ifndef FREQUENCY_HPP
#define FREQUENCY_HPP

/** Run the Height frequency scaling heuristic and add the frequency vector to the Algebra collection **/
pelib::Algebra
frequency_height(const pelib::Algebra &input);

/** Run the number of instructions as computed by a time complexity analysis of the Height frequency scaling heuristic with the given input problem **/
float
frequency_height_complexity(const pelib::Algebra &input);
 
#endif
