/*
 Copyright 2015 Nicolas Melot

 This file is part of Crown.

 Crown is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Crown is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Crown. If not, see <http://www.gnu.org/licenses/>.

*/


#include <pelib/Algebra.hpp>
#include <map>
#include <set>

#ifndef MAPPING_HPP
#define MAPPING_HPP

/** Add mapping vector "group" to Algebra collection using Longest Task, Lowest Group-first parallel task mapping heuristic **/
pelib::Algebra
mapping_ltlg(const pelib::Algebra &input);

/** Return the number of instruction as computed by a time complexity analysis of the LTLG heuristic for the given input **/
float
mapping_ltlg_complexity(const pelib::Algebra &input);

/** Return time in the number of instructions between the beginning of a schedule stage and the time the last task terminates **/
float
mapping_quality(const pelib::Algebra &input);

#endif
